function plotmesh(Gh,d,varargin)
  assert(strcmp(class(Gh),'fc_oogmsh.ooGmsh2'),'First parameter must be a <fc_oogmsh.ooGmsh2> object.\b  -> 1st parameter is a %s object\n',class(Gh))
  if ~fc_oogmsh.isgraphics(), return;end
  assert( (d>=0) && (d<=Gh.d) ) 
  p = inputParser;
  p.KeepUnmatched=true;
  p.addParamValue('color','k');
  p.addParamValue('interfaces',false);
  p.parse(varargin{:});
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  interfaces=p.Results.interfaces;
  Color=fc_tools.graphics.xcolor.val2rgb(p.Results.color);
  sElts=Gh.get_sElts_by_entityDim(d);
  if ~isempty(sElts)
    tags=unique(sElts.geo_lab)';
    if interfaces
      tags=tags(tags<0); % only interface elements
    else
      tags=tags(tags>0); % delete interface elements
    end
    n=length(tags);
    if n>0
      
      if ~ishold(),hold on;ho=false;else,ho=true;end
      for i=1:n
        me=sElts.me(:,sElts.geo_lab==tags(i));
        [q,me,toGlobal]=fc_oogmsh.msh.FromGlobalToLocal(Gh.q,me,Gh.toGlobal);
        fc_graphics4mesh.plotmesh(q,me,'color',Color,varargin{:})
      end
      if ~ho, hold off;end
    end
  end
end  
