classdef PDE %< handle
  properties %(SetAccess = protected)
    Op = [];
    f  = [];
    delta =[];
    dim = 0;
    d=0;
    m = 0;
    %ndof = 0;
    sym = false;
    name= '';
    AssemblyVersion='OptV3';
  end

  methods
    function self=PDE(Op,f,delta)
      if nargin==0, return;end
      assert( fc_vfemp1.is_Loperator(Op) || fc_vfemp1.is_Hoperator(Op) )
      self.dim=Op.dim;self.m=Op.m;self.d=Op.d;
      self.Op=Op;
      if nargin>=2
        if iscell(f)
          assert(length(f)==self.m);
          self.f=cell(1,self.m);
          for i=1:self.m
            self.f{i}=fc_vfemp1.Fdata(f{i});
          end
        else
          self.f=fc_vfemp1.Fdata(f);
        end
      end
      if nargin==3, self.delta=delta;else self.delta=zeros(1,self.m);end
    end
    
    function [A,b]=Assembly(self,sTh,varargin)
      %if nargin<=2,ndof=sTh.nq;end
      assert( fc_simesh.is_siMeshElt(sTh) )
      assert( (self.dim == sTh.dim) && (self.d == sTh.d) )
      p = inputParser;
      p.addParamValue('Num',1,@(x) ismember(x,[0,1]));
      p.addParamValue('local',true,@islogical);
      p.addParamValue('block',false,@islogical);
      p.parse(varargin{:});
      R=p.Results;
      
      if self.m>1
        b=fc_vfemp1.FEM.RHSAssembly(sTh,self.f,'m',self.m,'local',R.local,'Num',R.Num,'block',R.block);
      else
        b=fc_vfemp1.FEM.RHSAssembly(sTh,self.f,'local',R.local);
      end
      
      if isempty(self.Op)
        if R.local
          A=sparse(sTh.nq,sTh.nq);
        else
          A=sparse(sTh.nqParent,sTh.nqParent);
        end
        if R.block, A={A};b={b};end
      end
      
      
      if fc_vfemp1.is_Loperator(self.Op)
        A=fc_vfemp1.FEM.DAssemblyP1_OptV3new(sTh,self.Op,'local',R.local);
%          if ~isempty(self.f)
%            Mop=fc_vfemp1.Loperator(sTh.dim,sTh.d,[],[],[],self.f);
%            M=fc_vfemp1.FEM.DAssemblyP1_OptV3new(sTh,Mop);
%            f=M*ones(sTh.nq,1);
%            if R.local
%              b=f;
%            else b=zeros(sTh.nqParent,1);b(sTh.toParent)=f;end
%          else
%            if R.local, b=zeros(sTh.nq,1);else b=zeros(sTh.nqParent,1);end
%          end
        if R.block, A={A};b={b};end
        return
      end
      if fc_vfemp1.is_Hoperator(self.Op)
        A=fc_vfemp1.FEM.HAssemblyP1_OptV3(sTh,self.Op,'local',R.local,'Num',R.Num,'block',R.block);
        %b=fc_vfemp1.FEM.RHSAssembly(sTh,self.f,'m',self.m,'local',R.local,'Num',R.Num,'block',R.block);
        return
      end
      
    end    
 
    function self=zeros(self,dim,d,m)
      self.dim=dim;
      self.d=d;
      self.m=m;
      self.delta=ones(1,m); % default Homegeneous Neumann
      %if m>1
        self.Op=fc_vfemp1.Hoperator(dim,d,m);
        self.f=cell(1,m);
%        else
%          self.Op=fc_vfemp1.Loperator(dim,d,[],[],[],[]);
%          self.f=[];
%        end
    end 
 
  end % methods
end % classdef
